CREATE OR REPLACE PROCEDURE IMPOSTO_RELGESDIRETA(
   P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
   P_DATAINI    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DATAFIM    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRAPURACGD IN TRAB_APURAC_GD.NRAPURACGD%TYPE)
IS
   V_IDENDCFOP    VARCHAR2(01);
   V_CDGRUPOFISC  VARCHAR2(03);
   V_TIPOOPER     VARCHAR2(02);
   V_CDEMPRESA    VARCHAR2(02);
   V_CDINSCESTA   VARCHAR2(16);
   V_PAISORIG     VARCHAR2(04);
   V_ESTAORIG     VARCHAR2(02);
   V_MUNIORIG     VARCHAR2(04);
   V_PAISDEST     VARCHAR2(04);
   V_ESTADEST     VARCHAR2(02);
   V_MUNIDEST     VARCHAR2(04);
   V_NRALIQTEMP   VARCHAR2(14);
   V_NRLANCTONF   VARCHAR2(20);
   V_IDENDEMIS    VARCHAR2(01);
   V_IDTRIMPSTII  VARCHAR2(01);
   V_PARDEDTMP    NUMBER;
   V_PREDBCTMP    NUMBER;
   V_ALIQUTMP     NUMBER;
   V_TRATIMPST    VARCHAR2(01);
   V_PBCSUBTRIB   NUMBER;
   V_IDPMCBASECAL VARCHAR2(01);
   V_CDIMPOSTRIB  VARCHAR2(02);
   V_IDVRIMPSTRIB VARCHAR2(01);
   V_VRMAXVENDA   NUMBER;
   V_VRPEMAXVENDA NUMBER;
   V_TAXABASECALC NUMBER;
   V_TAXAALIQUOTA NUMBER;
   V_TAXABCSUBSTR NUMBER;
   V_BASECALCIT   NUMBER;
   V_PERDBCALC    NUMBER;
   V_IMPOSTOIT    NUMBER;
   V_BASECALCTO   NUMBER;
   V_BASEVLRMAX   NUMBER;
   V_CALCVLRMAX   NUMBER;
   V_IMPOSTOTAL   NUMBER;
   V_IDINTEREST   VARCHAR2(01);
BEGIN
   V_TIPOOPER := '01';

   BEGIN
      SELECT NVL(IDENDCFOPFIL,'I'), CDEMPRESA, CDINSCESTA
      INTO V_IDENDCFOP, V_CDEMPRESA, V_CDINSCESTA
      FROM FILIAL
      WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDENDCFOP  := 'I';
         V_CDEMPRESA  := NULL;
         V_CDINSCESTA := NULL;
   END;

   NOVO_CODIGO_SC('LANCNF/FILIAL'||P_CDFILIAL, V_NRLANCTONF);

   V_NRLANCTONF := SUBSTR(V_NRLANCTONF, 10, 10);

   FOR C_FATURA IN (SELECT CDFILIALAPGD, CDCLIENTEAPGD, CDSERVFILIAPGD, P.CDARVPROD, DTAPURACFATGD, NRAPURACGD,
                           CDPRODUTOAPGD, NREFETIVOSAPGD, VRPRECUNITAPGD, ROUND(VRPRECUNITAPGD * NREFETIVOSAPGD,2) AS VRFATUR
                    FROM TRAB_APURAC_GD T, PRODUTO P
                    WHERE CDFILIALAPGD    = P_CDFILIAL                   AND
                          DTAPURACFATGD BETWEEN P_DATAINI AND P_DATAFIM  AND
                          NRAPURACGD      = P_NRAPURACGD  AND
                          T.CDPRODUTOAPGD = P.CDPRODUTO) LOOP
      BEGIN
         SELECT NVL(IDENDEMISCLI, 'P')
         INTO V_IDENDEMIS
         FROM CLIENTE
         WHERE (CDCLIENTE = C_FATURA.CDCLIENTEAPGD);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDEMIS := 'P';
      END;

      IF V_IDENDCFOP = 'I' THEN
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA
              AND CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               Null;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFILI
            WHERE (CDFILIAL     = C_FATURA.CDFILIALAPGD)
              AND (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               Null;
         END;
      END IF;

      BEGIN
         SELECT CDPAIS, SGESTADO, CDMUNICIPIO
         INTO V_PAISDEST, V_ESTADEST, V_MUNIDEST
         FROM ENDECLIE
         WHERE (CDCLIENTE    = C_FATURA.CDCLIENTEAPGD) AND
               (IDTPENDECLIE = V_IDENDEMIS);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PAISDEST := NULL;
            V_ESTADEST := NULL;
            V_MUNIDEST := NULL;
      END;

      V_IDINTEREST := 'N';
      IF (V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG) THEN
         V_IDINTEREST := 'S';
      END IF;

      CONSULTA_GRUPOFISCAL('C', C_FATURA.CDCLIENTEAPGD, C_FATURA.CDFILIALAPGD, 'S', V_TIPOOPER, V_CDGRUPOFISC);

      CONSULTA_INCIDENCIA('S', V_CDEMPRESA, C_FATURA.CDARVPROD, V_CDINSCESTA, V_TIPOOPER, P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, null, V_IDINTEREST);

      V_IMPOSTOTAL := 0;
      FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                  IDCONSISTENT, IDIMPORECUP, IP.IDTRATIMPO
                           FROM INCITEMP IT, IMPOSTO IP
                           WHERE (IT.NRINCITEMP = P_CDFILIAL||V_NRLANCTONF) AND
                                 (IP.CDIMPOSTO  = IT.CDIMPOTEMP)            AND
                                 (IP.IDPRODNOTA = 'P')
                           ORDER BY CDIMPOTEMP) LOOP

         IF C_INCIDENCIA.IDUTMUNIORIG = 'D' THEN
            /* CONSIDERA O MUNICIPIO DE DESTINO */
            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', V_CDEMPRESA, C_FATURA.CDARVPROD, V_CDINSCESTA, V_PAISORIG,
                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, C_FATURA.VRFATUR, C_FATURA.DTAPURACFATGD, P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, V_TIPOOPER);

         ELSE
           /* CONSIDERA O MUNICIPIO DE ORIGEM */
            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', V_CDEMPRESA, C_FATURA.CDARVPROD, V_CDINSCESTA, V_PAISORIG,
                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, C_FATURA.VRFATUR, C_FATURA.DTAPURACFATGD, P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, V_TIPOOPER);
         END IF;

         V_NRALIQTEMP := 0;
         V_PARDEDTMP  := 0;
         V_PREDBCTMP  := 0;
         V_ALIQUTMP   := 0;
         V_IMPOSTOIT  := 0;

         BEGIN
            SELECT NVL(NRALIQTEMP,0), NVL(VRPARDEDTMP,0), NVL(VRPREDBCTMP,0), NVL(VRALIQUTMP,0),
                   NVL(IDTRIMPSTTMP, '0'), NVL(VRPBCSTTMP,0), NVL(IDPMCBSCALTMP, 'S')
            INTO V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP, V_TRATIMPST, V_PBCSUBTRIB, V_IDPMCBASECAL
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAL||V_NRLANCTONF);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRALIQTEMP   := 0;
               V_PARDEDTMP    := 0;
               V_PREDBCTMP    := 0;
               V_ALIQUTMP     := 0;
               V_TRATIMPST    := 0;
               V_PBCSUBTRIB   := 0;
               V_IDPMCBASECAL := 0;
         END;

         BEGIN
            SELECT CDIMPOSTO, IDVRIMPSTRIB
            INTO V_CDIMPOSTRIB, V_IDVRIMPSTRIB
            FROM IMPOSTO
            WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDIMPOSTRIB  := NULL;
               V_IDVRIMPSTRIB := NULL;
         END;

         V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
         V_TAXAALIQUOTA := (V_ALIQUTMP/100);
         V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
         V_BASECALCIT   := C_FATURA.VRFATUR * V_TAXABASECALC;

         V_PERDBCALC    := 100 - V_PREDBCTMP;

         IF V_PBCSUBTRIB > 0 THEN
            V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
            V_PREDBCTMP  := V_PBCSUBTRIB;
            V_PERDBCALC  := 0;
         END IF;

         V_BASEVLRMAX   := 0;
         V_VRPEMAXVENDA := 0;
         V_VRMAXVENDA   := 0;
         V_CALCVLRMAX   := 0;

         BEGIN
            SELECT NVL(VRMAXVENDA,0), NVL(VRPEMAXVENDA,0)
            INTO V_VRMAXVENDA, V_VRPEMAXVENDA
            FROM VRMAXVENPROD A
            WHERE (CDPAIS   = V_PAISDEST)          AND
                  (SGESTADO = V_ESTADEST)          AND
                  (A.CDPRODUTO = C_FATURA.CDPRODUTOAPGD);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRMAXVENDA   := 0;
               V_VRPEMAXVENDA := 0;
         END;

         IF V_VRMAXVENDA IS NOT NULL THEN
            V_CALCVLRMAX := (C_FATURA.NREFETIVOSAPGD * V_VRMAXVENDA) * (V_VRPEMAXVENDA/100);
            V_BASEVLRMAX := V_CALCVLRMAX;
         END IF;

         IF V_CDIMPOSTRIB IS NULL THEN
            V_BASECALCTO  := V_BASECALCIT;
            V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
         ELSE
            /*Se o parametro de "Utiliza PMC" estiver marcado eu comparo o percentual de majorao com o valor maximo
            de venda e o maior entra na base de calculo. Se o parametro estiver desmarcado sempre sera utilizado o percentual de
            majorao */
            IF NVL(V_IDPMCBASECAL, 'S') = 'S' THEN
               IF V_BASECALCIT > V_BASEVLRMAX THEN
                  V_BASECALCTO  := V_BASECALCIT;
                  V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
               ELSE
                  V_BASECALCTO  := V_BASEVLRMAX;
                  V_IMPOSTOIT   := (V_BASEVLRMAX * V_TAXAALIQUOTA) - V_PARDEDTMP;
               END IF;
            ELSE
               V_BASECALCTO  := V_BASECALCIT;
               V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
            END IF;
         END IF;

         IF V_CDIMPOSTRIB IS NULL THEN
            V_IDTRIMPSTII := '';
         ELSE
            V_IDTRIMPSTII := V_TRATIMPST;
         END IF;

         IF (V_IMPOSTOIT < 0) THEN
            V_IMPOSTOIT := 0;
         END IF;

         IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
            V_BASECALCTO := 0;
         END IF;

         IF C_INCIDENCIA.IDTRATIMPO = 'D' THEN
            V_IMPOSTOTAL := V_IMPOSTOTAL - ROUND(V_IMPOSTOIT,2);
         ELSE
            V_IMPOSTOTAL := V_IMPOSTOTAL + ROUND(V_IMPOSTOIT,2);
         END IF;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = P_CDFILIAL||V_NRLANCTONF;
      END LOOP;


      UPDATE TRAB_APURAC_GD
      SET VRIMPOSPRODGD = V_IMPOSTOTAL
      WHERE CDFILIALAPGD   = C_FATURA.CDFILIALAPGD   AND
            CDCLIENTEAPGD  = C_FATURA.CDCLIENTEAPGD  AND
            CDSERVFILIAPGD = C_FATURA.CDSERVFILIAPGD AND
            VRPRECUNITAPGD = C_FATURA.VRPRECUNITAPGD AND
            NRAPURACGD     = C_FATURA.NRAPURACGD     AND
            DTAPURACFATGD  = C_FATURA.DTAPURACFATGD;

      DELETE INCITEMP
      WHERE NRINCITEMP = P_CDFILIAL||V_NRLANCTONF;
   END LOOP;

   /*Apurao por turno*/

   FOR C_FATURNO IN (SELECT CDFILIALAPTU, CDCLIENTEAPTU, CDSERVFILIAPTU, CDTURNOTU, P.CDARVPROD, DTAPURACFATTU, NRAPURACTU,
                            CDPRODUTOAPTU, NREFETIVOSAPTU, VRPRECUNITAPTU, ROUND(NREFETIVOSAPTU * VRPRECUNITAPTU,2) AS VRFATUR
                      FROM TRAB_APURAC_TU T, PRODUTO P
                      WHERE CDFILIALAPTU    = P_CDFILIAL                    AND
                            DTAPURACFATTU BETWEEN P_DATAINI AND P_DATAFIM  AND
                            NRAPURACTU      = P_NRAPURACGD  AND
                            T.CDPRODUTOAPTU = P.CDPRODUTO) LOOP
      BEGIN
         SELECT NVL(IDENDEMISCLI, 'P')
         INTO V_IDENDEMIS
         FROM CLIENTE
         WHERE (CDCLIENTE = C_FATURNO.CDCLIENTEAPTU);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDEMIS := 'P';
      END;

      IF V_IDENDCFOP = 'I' THEN
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA
              AND CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               Null;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFILI
            WHERE (CDFILIAL     = C_FATURNO.CDFILIALAPTU)
              AND (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               Null;
         END;
      END IF;

      BEGIN
         SELECT CDPAIS, SGESTADO, CDMUNICIPIO
         INTO V_PAISDEST, V_ESTADEST, V_MUNIDEST
         FROM ENDECLIE
         WHERE (CDCLIENTE    = C_FATURNO.CDCLIENTEAPTU) AND
               (IDTPENDECLIE = V_IDENDEMIS);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PAISDEST := NULL;
            V_ESTADEST := NULL;
            V_MUNIDEST := NULL;
      END;

      V_IDINTEREST := 'N';
      IF (V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG) THEN
         V_IDINTEREST := 'S';
      END IF;

      CONSULTA_GRUPOFISCAL('C', C_FATURNO.CDCLIENTEAPTU, C_FATURNO.CDFILIALAPTU, 'S', V_TIPOOPER, V_CDGRUPOFISC);

      CONSULTA_INCIDENCIA('S', V_CDEMPRESA, C_FATURNO.CDARVPROD, V_CDINSCESTA, V_TIPOOPER, P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, null, V_IDINTEREST);

      V_IMPOSTOTAL := 0;
      FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                  IDCONSISTENT, IDIMPORECUP, IP.IDTRATIMPO
                           FROM INCITEMP IT, IMPOSTO IP
                           WHERE (IT.NRINCITEMP = P_CDFILIAL||V_NRLANCTONF) AND
                                 (IP.CDIMPOSTO  = IT.CDIMPOTEMP)            AND
                                 (IP.IDPRODNOTA = 'P')
                           ORDER BY CDIMPOTEMP) LOOP

         IF C_INCIDENCIA.IDUTMUNIORIG = 'D' THEN
            /* CONSIDERA O MUNICIPIO DE DESTINO */
            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', V_CDEMPRESA, C_FATURNO.CDARVPROD, V_CDINSCESTA, V_PAISORIG,
                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, C_FATURNO.VRFATUR, C_FATURNO.DTAPURACFATTU,
                              P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, V_TIPOOPER);

         ELSE
           /* CONSIDERA O MUNICIPIO DE ORIGEM */
            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', V_CDEMPRESA, C_FATURNO.CDARVPROD, V_CDINSCESTA, V_PAISORIG,
                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, C_FATURNO.VRFATUR, C_FATURNO.DTAPURACFATTU,
                              P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, V_TIPOOPER);
         END IF;

         V_NRALIQTEMP := 0;
         V_PARDEDTMP  := 0;
         V_PREDBCTMP  := 0;
         V_ALIQUTMP   := 0;
         V_IMPOSTOIT  := 0;

         BEGIN
            SELECT NVL(NRALIQTEMP,0), NVL(VRPARDEDTMP,0), NVL(VRPREDBCTMP,0), NVL(VRALIQUTMP,0),
                   NVL(IDTRIMPSTTMP, '0'), NVL(VRPBCSTTMP,0), NVL(IDPMCBSCALTMP, 'S')
            INTO V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP, V_TRATIMPST, V_PBCSUBTRIB, V_IDPMCBASECAL
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAL||V_NRLANCTONF);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRALIQTEMP   := 0;
               V_PARDEDTMP    := 0;
               V_PREDBCTMP    := 0;
               V_ALIQUTMP     := 0;
               V_TRATIMPST    := 0;
               V_PBCSUBTRIB   := 0;
               V_IDPMCBASECAL := 0;
         END;

         BEGIN
            SELECT CDIMPOSTO, IDVRIMPSTRIB
            INTO V_CDIMPOSTRIB, V_IDVRIMPSTRIB
            FROM IMPOSTO
            WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDIMPOSTRIB  := NULL;
               V_IDVRIMPSTRIB := NULL;
         END;

         V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
         V_TAXAALIQUOTA := (V_ALIQUTMP/100);
         V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
         V_BASECALCIT := C_FATURNO.VRFATUR * V_TAXABASECALC;

         V_PERDBCALC    := 100 - V_PREDBCTMP;

         IF V_PBCSUBTRIB > 0 THEN
            V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
            V_PREDBCTMP  := V_PBCSUBTRIB;
            V_PERDBCALC  := 0;
         END IF;

         V_BASEVLRMAX  := 0;
         V_VRPEMAXVENDA := 0;
         V_VRMAXVENDA  := 0;
         V_CALCVLRMAX  := 0;

         BEGIN
            SELECT NVL(VRMAXVENDA,0), NVL(VRPEMAXVENDA,0)
            INTO V_VRMAXVENDA, V_VRPEMAXVENDA
            FROM VRMAXVENPROD A
            WHERE (CDPAIS   = V_PAISDEST)          AND
                  (SGESTADO = V_ESTADEST)          AND
                  (A.CDPRODUTO = C_FATURNO.CDPRODUTOAPTU);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRMAXVENDA   := 0;
               V_VRPEMAXVENDA := 0;
         END;

         IF V_VRMAXVENDA IS NOT NULL THEN
            V_CALCVLRMAX := (C_FATURNO.NREFETIVOSAPTU * V_VRMAXVENDA) * (V_VRPEMAXVENDA/100);
            V_BASEVLRMAX := V_CALCVLRMAX;
         END IF;

         IF V_CDIMPOSTRIB IS NULL THEN
            V_BASECALCTO  := V_BASECALCIT;
            V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
         ELSE
            /*Se o parametro de "Utiliza PMC" estiver marcado eu comparo o percentual de majorao com o valor maximo
            de venda e o maior entra na base de calculo. Se o parametro estiver desmarcado sempre sera utilizado o percentual de
            majorao */
            IF NVL(V_IDPMCBASECAL, 'S') = 'S' THEN
               IF V_BASECALCIT > V_BASEVLRMAX THEN
                  V_BASECALCTO  := V_BASECALCIT;
                  V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
               ELSE
                  V_BASECALCTO  := V_BASEVLRMAX;
                  V_IMPOSTOIT   := (V_BASEVLRMAX * V_TAXAALIQUOTA) - V_PARDEDTMP;
               END IF;
            ELSE
               V_BASECALCTO  := V_BASECALCIT;
               V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
            END IF;
         END IF;

         IF V_CDIMPOSTRIB IS NULL THEN
            V_IDTRIMPSTII := '';
         ELSE
            V_IDTRIMPSTII := V_TRATIMPST;
         END IF;

         IF (V_IMPOSTOIT < 0) THEN
            V_IMPOSTOIT := 0;
         END IF;

         IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
            V_BASECALCTO := 0;
         END IF;

         IF C_INCIDENCIA.IDTRATIMPO = 'D' THEN
            V_IMPOSTOTAL := V_IMPOSTOTAL - ROUND(V_IMPOSTOIT,2);
         ELSE
            V_IMPOSTOTAL := V_IMPOSTOTAL + ROUND(V_IMPOSTOIT,2);
         END IF;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = P_CDFILIAL||V_NRLANCTONF;
      END LOOP;

      UPDATE TRAB_APURAC_TU
      SET VRIMPOSPRODTU = V_IMPOSTOTAL
      WHERE CDFILIALAPTU   = C_FATURNO.CDFILIALAPTU   AND
            CDCLIENTEAPTU  = C_FATURNO.CDCLIENTEAPTU  AND
            CDSERVFILIAPTU = C_FATURNO.CDSERVFILIAPTU AND
            VRPRECUNITAPTU = C_FATURNO.VRPRECUNITAPTU AND
            NRAPURACTU     = C_FATURNO.NRAPURACTU     AND
            DTAPURACFATTU  = C_FATURNO.DTAPURACFATTU  AND
            CDTURNOTU      = C_FATURNO.CDTURNOTU;

      DELETE INCITEMP
      WHERE NRINCITEMP = P_CDFILIAL||V_NRLANCTONF;
   END LOOP;
   /*Apurao por Equivalencia*/



   FOR C_FATEQUIV IN (SELECT CDFILIALAPEQ, CDCLIENTEAPEQ, CDSERVFILIAPEQ, CDSERVPREQUI, P.CDARVPROD, DTAPURACFATEQ, NRAPURACEQ,
                             CDPRODUTOAPEQ, NREFETIVOSAPEQ, VRPRECUNITAPEQ, ROUND(NREFETIVOSAPEQ * VRPRECUNITAPEQ,2) AS VRFATUR
                      FROM TRAB_APURAC_EQ T, PRODUTO P
                      WHERE CDFILIALAPEQ    = P_CDFILIAL                    AND
                            DTAPURACFATEQ BETWEEN P_DATAINI AND P_DATAFIM  AND
                            NRAPURACEQ      = P_NRAPURACGD  AND
                            T.CDPRODUTOAPEQ = P.CDPRODUTO) LOOP
      BEGIN
         SELECT NVL(IDENDEMISCLI, 'P')
         INTO V_IDENDEMIS
         FROM CLIENTE
         WHERE (CDCLIENTE = C_FATEQUIV.CDCLIENTEAPEQ);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDEMIS := 'P';
      END;

      IF V_IDENDCFOP = 'I' THEN
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA
              AND CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               Null;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFILI
            WHERE (CDFILIAL     = C_FATEQUIV.CDFILIALAPEQ)
              AND (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               Null;
         END;
      END IF;

      BEGIN
         SELECT CDPAIS, SGESTADO, CDMUNICIPIO
         INTO V_PAISDEST, V_ESTADEST, V_MUNIDEST
         FROM ENDECLIE
         WHERE (CDCLIENTE    = C_FATEQUIV.CDCLIENTEAPEQ) AND
               (IDTPENDECLIE = V_IDENDEMIS);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PAISDEST := NULL;
            V_ESTADEST := NULL;
            V_MUNIDEST := NULL;
      END;
      V_IDINTEREST := 'N';
      IF (V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG) THEN
         V_IDINTEREST := 'S';
      END IF;

      CONSULTA_GRUPOFISCAL('C', C_FATEQUIV.CDCLIENTEAPEQ, C_FATEQUIV.CDFILIALAPEQ, 'S', V_TIPOOPER, V_CDGRUPOFISC);

      CONSULTA_INCIDENCIA('S', V_CDEMPRESA, C_FATEQUIV.CDARVPROD, V_CDINSCESTA, V_TIPOOPER, P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, null, V_IDINTEREST);

      V_IMPOSTOTAL := 0;
      FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                  IDCONSISTENT, IDIMPORECUP, IP.IDTRATIMPO
                           FROM INCITEMP IT, IMPOSTO IP
                           WHERE (IT.NRINCITEMP = P_CDFILIAL||V_NRLANCTONF) AND
                                 (IP.CDIMPOSTO  = IT.CDIMPOTEMP)            AND
                                 (IP.IDPRODNOTA = 'P')
                           ORDER BY CDIMPOTEMP) LOOP

         IF C_INCIDENCIA.IDUTMUNIORIG = 'D' THEN
            /* CONSIDERA O MUNICIPIO DE DESTINO */
            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', V_CDEMPRESA, C_FATEQUIV.CDARVPROD, V_CDINSCESTA, V_PAISORIG,
                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, C_FATEQUIV.VRFATUR, C_FATEQUIV.DTAPURACFATEQ,
                              P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, V_TIPOOPER);

         ELSE
           /* CONSIDERA O MUNICIPIO DE ORIGEM */
            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', V_CDEMPRESA, C_FATEQUIV.CDARVPROD, V_CDINSCESTA, V_PAISORIG,
                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, C_FATEQUIV.VRFATUR, C_FATEQUIV.DTAPURACFATEQ,
                              P_CDFILIAL, V_NRLANCTONF, V_CDGRUPOFISC, V_TIPOOPER);
         END IF;

         V_NRALIQTEMP := 0;
         V_PARDEDTMP  := 0;
         V_PREDBCTMP  := 0;
         V_ALIQUTMP   := 0;
         V_IMPOSTOIT  := 0;

         BEGIN
            SELECT NVL(NRALIQTEMP,0), NVL(VRPARDEDTMP,0), NVL(VRPREDBCTMP,0), NVL(VRALIQUTMP,0),
                   NVL(IDTRIMPSTTMP, '0'), NVL(VRPBCSTTMP,0), NVL(IDPMCBSCALTMP, 'S')
            INTO V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP, V_TRATIMPST, V_PBCSUBTRIB, V_IDPMCBASECAL
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAL||V_NRLANCTONF);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRALIQTEMP   := 0;
               V_PARDEDTMP    := 0;
               V_PREDBCTMP    := 0;
               V_ALIQUTMP     := 0;
               V_TRATIMPST    := 0;
               V_PBCSUBTRIB   := 0;
               V_IDPMCBASECAL := 0;
         END;

         BEGIN
            SELECT CDIMPOSTO, IDVRIMPSTRIB
            INTO V_CDIMPOSTRIB, V_IDVRIMPSTRIB
            FROM IMPOSTO
            WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDIMPOSTRIB  := NULL;
               V_IDVRIMPSTRIB := NULL;
         END;

         V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
         V_TAXAALIQUOTA := (V_ALIQUTMP/100);
         V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
         V_BASECALCIT := C_FATEQUIV.VRFATUR * V_TAXABASECALC;

         V_PERDBCALC    := 100 - V_PREDBCTMP;

         IF V_PBCSUBTRIB > 0 THEN
            V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
            V_PREDBCTMP  := V_PBCSUBTRIB;
            V_PERDBCALC  := 0;
         END IF;

         V_BASEVLRMAX  := 0;
         V_VRPEMAXVENDA := 0;
         V_VRMAXVENDA  := 0;
         V_CALCVLRMAX  := 0;

         BEGIN
            SELECT NVL(VRMAXVENDA,0), NVL(VRPEMAXVENDA,0)
            INTO V_VRMAXVENDA, V_VRPEMAXVENDA
            FROM VRMAXVENPROD A
            WHERE (CDPAIS   = V_PAISDEST)          AND
                  (SGESTADO = V_ESTADEST)          AND
                  (A.CDPRODUTO = C_FATEQUIV.CDPRODUTOAPEQ);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRMAXVENDA   := 0;
               V_VRPEMAXVENDA := 0;
         END;

         IF V_VRMAXVENDA IS NOT NULL THEN
            V_CALCVLRMAX := (C_FATEQUIV.NREFETIVOSAPEQ * V_VRMAXVENDA) * (V_VRPEMAXVENDA/100);
            V_BASEVLRMAX := V_CALCVLRMAX;
         END IF;

         IF V_CDIMPOSTRIB IS NULL THEN
            V_BASECALCTO  := V_BASECALCIT;
            V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
         ELSE
            /*Se o parametro de "Utiliza PMC" estiver marcado eu comparo o percentual de majorao com o valor maximo
            de venda e o maior entra na base de calculo. Se o parametro estiver desmarcado sempre sera utilizado o percentual de
            majorao */
            IF NVL(V_IDPMCBASECAL, 'S') = 'S' THEN
               IF V_BASECALCIT > V_BASEVLRMAX THEN
                  V_BASECALCTO  := V_BASECALCIT;
                  V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
               ELSE
                  V_BASECALCTO  := V_BASEVLRMAX;
                  V_IMPOSTOIT   := (V_BASEVLRMAX * V_TAXAALIQUOTA) - V_PARDEDTMP;
               END IF;
            ELSE
               V_BASECALCTO  := V_BASECALCIT;
               V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
            END IF;
         END IF;

         IF V_CDIMPOSTRIB IS NULL THEN
            V_IDTRIMPSTII := '';
         ELSE
            V_IDTRIMPSTII := V_TRATIMPST;
         END IF;

         IF (V_IMPOSTOIT < 0) THEN
            V_IMPOSTOIT := 0;
         END IF;

         IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
            V_BASECALCTO := 0;
         END IF;

         IF C_INCIDENCIA.IDTRATIMPO = 'D' THEN
            V_IMPOSTOTAL := V_IMPOSTOTAL - ROUND(V_IMPOSTOIT,2);
         ELSE
            V_IMPOSTOTAL := V_IMPOSTOTAL + ROUND(V_IMPOSTOIT,2);
         END IF;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = P_CDFILIAL||V_NRLANCTONF;
      END LOOP;

      UPDATE TRAB_APURAC_EQ
      SET VRIMPOSPRODEQ = V_IMPOSTOTAL
      WHERE CDFILIALAPEQ   = C_FATEQUIV.CDFILIALAPEQ   AND
            CDCLIENTEAPEQ  = C_FATEQUIV.CDCLIENTEAPEQ  AND
            CDSERVFILIAPEQ = C_FATEQUIV.CDSERVFILIAPEQ AND
            VRPRECUNITAPEQ = C_FATEQUIV.VRPRECUNITAPEQ AND
            NRAPURACEQ     = C_FATEQUIV.NRAPURACEQ     AND
            DTAPURACFATEQ  = C_FATEQUIV.DTAPURACFATEQ  AND
            CDSERVPREQUI   = C_FATEQUIV.CDSERVPREQUI;
      DELETE INCITEMP
      WHERE NRINCITEMP = P_CDFILIAL||V_NRLANCTONF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPOSTO_RELGESDIRETA','5.01.003'); END;
/

